﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading; 
using UrlMgr;

namespace UrlMgr
{
    public partial class Main : BaseForm
    {  
        private List<Catalog> V_Catalog
        {
            get { return ViewState["V_Catalog"] as List<Catalog>; }
            set { ViewState["V_Catalog"] = value; }
        }

        private UrlNode curUrlNode
        {
            get
            {
                return ViewState["curUrlNode"] as UrlNode;
            }
            set
            {
                ViewState["curUrlNode"] = value;
            }
        }

        public Main()
        {
            InitializeComponent(); 
            //
            this.BindCatalog(true); 
            //
            this.curUrlNode = new UrlNode();
            if (cbxCatalogType.Items != null)
            { 
                cbxCatalogType.SelectedIndex = cbxCatalogType.Items.IndexOfValue("ID", MySettings.MySet_DefaultCatalogID);
                //
                this.curUrlNode.CatalogID = cbxCatalogType.SelectedValue.ToString().Trim();
                //
                this.BindUrlNode(this.curUrlNode.CatalogID); 
            }

        }

        /// <summary>
        /// 打开网站
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnGo_Click(object sender, EventArgs e)
        {
            wbsMain.Navigate(txtUrl.Text.Trim());
        }

        //private void tvUrl_MouseDown(object sender, MouseEventArgs e)
        //{
        //    this.ShowUrlMrgHelpMenu(sender, e);
        //}
        //private void ShowUrlMrgHelpMenu(object sender, MouseEventArgs e)
        //{
        //    int i = 0;
        //    ContextMenu cMenu_tvCatalog = null;
        //    cMenu_tvCatalog = new ContextMenu();
        //    cMenu_tvCatalog.MenuItems.Add(
        //        new MenuItem(
        //            "管理节点",
        //            this.AddUrlNode
        //            ));
        //    cMenu_tvCatalog.MenuItems.Add(
        //        new MenuItem(
        //            "编辑节点",
        //            this.BindUrlNodeHander
        //            ));
        //    cMenu_tvCatalog.Show(tvUrl, e.Location); 
        //}

        /// <summary>
        /// 创建分类信息
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnNew_Click(object sender, EventArgs e)
        {
            CatalogMgr frmCatalogMgr = new CatalogMgr();
            frmCatalogMgr.ShowDialog(); 
        }

        /// <summary>
        /// 默认显示分类
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSave_Click(object sender, EventArgs e)
        {
            if (cbxCatalogType.SelectedItem != null)
            {
                try
                {
                    MySettings.MySet_DefaultCatalogID = cbxCatalogType.SelectedValue.ToString().Trim();
                }
                catch (Exception ex)
                {
                    MessageBox.Show("设置默认分类，操作失败！\n请联系管理员！", "系统异常", MessageBoxButtons.OK);
                }
            }
        }

        /// <summary>
        /// 添加链接
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void AddUrlNode(object sender, EventArgs e)
        {
            if (wbsMain.Url == null)
            {
                if (txtUrl.Text.Trim() != "")
                {
                    wbsMain.Navigate(txtUrl.Text.Trim());

                    #region 
                    //Thread openUrl = new Thread(delegate()
                    //    {
                    //        wbsMain.Navigate(txtUrl.Text.Trim());
                    //    });
                    //openUrl.Name = "Thread for Open Url";
                    //openUrl.Priority = ThreadPriority.Highest;
                    ////
                    //openUrl.Start();
                    //Thread.Sleep(2000);
                    //while (true)
                    //{
                    //    if (wbsMain.StatusText == "")
                    //    {
                    //        openUrl.Abort();
                    //        break;
                    //    }
                    //    else
                    //    {
                    //        TThread.Sleep(1000);
                    //    } 
                    //}
                    #endregion
                }
                else
                { 
                    MessageBox.Show("请输入和打开链接地址", "系统警告", MessageBoxButtons.OK);
                    return;
                }
            }

            this.curUrlNode = new UrlNode()
                {
                    ID = Guid.NewGuid().ToString().Trim(),
                    CatalogID = this.curUrlNode.CatalogID,
                };

            if (txtUrl.Text.Trim().ToLower() != "")
            {
                this.curUrlNode.CatalogID = cbxCatalogType.SelectedValue.ToString().Trim();
                if (tvUrl.Nodes != null && tvUrl.Nodes.Count > 0 && tvUrl.SelectedNode != null)
                {
                    this.curUrlNode.ParentID = tvUrl.SelectedNode.Tag.ToString();
                }
                this.curUrlNode.Title = wbsMain.DocumentTitle.Trim();
                this.curUrlNode.Desc = this.curUrlNode.Title;
                this.curUrlNode.Url = wbsMain.Url.ToString().Trim().ToLower();
                this.curUrlNode.Creator = System.Environment.UserName;
                this.curUrlNode.CreateTime = DateTime.Now;
                //
                UrlNodeMgr urlnodemagr = new UrlNodeMgr();
                if (urlnodemagr.ReceiveMessage("curUrlNode", this.curUrlNode))
                {
                    urlnodemagr.ShowDialog();
                }
            } 
        }  

        /// <summary>
        /// 删除链接
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void DelUrlNode(object sender, EventArgs e)
        {

        }

        /// <summary>
        /// 修改链接
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void SetUrlNode(object sender, EventArgs e)
        {

        }

        /// <summary>
        /// 查询链接
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void GetUrlNode(object sender, EventArgs e)
        {

        }

        /// <summary>
        /// 选择分类
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void cbxCatalogType_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.curUrlNode = new UrlNode()
            {
                CatalogID = cbxCatalogType.SelectedValue.ToString().Trim()
            };
            //
            this.BindUrlNode(this.curUrlNode.CatalogID);
        }

        /// <summary>
        /// 构造网址收藏树形图
        /// </summary>
        /// <param name="CatalogID"></param> 
        private void BindUrlNode(string CatalogID)
        {
            List<UrlNode> list = null;
            List<UrlNode> root = null;
            List<UrlNode> son = null;
            TreeNode rnode = null; 

            if (tvUrl.Nodes.Count > 0)
            {
                tvUrl.Nodes.Clear();
            }

            try
            {
                list = MyAction.GetUrlNode(
                    new UrlNode()
                    {
                        CatalogID = this.curUrlNode.CatalogID
                    }
                    );

                if (list != null)
                {
                    root =
                        (from obj in list 
                        where obj.ParentID.Equals("")
                        select obj).ToList<UrlNode>();

                    if(root == null || root.Count == 0)
                    { 
                        MessageBox.Show("数据没有根节点，\n\n请联系管理员检查数据！", "", MessageBoxButtons.OK);
                        return;
                    }

                    // 升序排序
                    root.Sort(delegate(UrlNode x, UrlNode y)
                    {
                        return Comparer<string>.Default.Compare(x.SortCode, y.SortCode);
                    });
                    for (int i = root.Count; i > 0;i--)
                    {
                        rnode = new TreeNode()
                            {
                                Text = root[0].Title,
                                ToolTipText = root[0].Desc,
                                //Tag = string.Format("{0},{1}", root[0].CatalogID, root[0].ID)
                                Tag = root[0].ID
                            };

                        tvUrl.Nodes.Add(rnode); 

                        this.LoopUrlNode(rnode, list);

                        // 回收资源
                        list.Remove(root[0]);
                        root.RemoveAt(0);
                    }
                } 
            }
            catch(Exception ex)
            {
                MessageBox.Show(string.Format("发生异常:\n{0}", ex.Message), "", MessageBoxButtons.OK);
                return;
            }
            finally
            { 
                tvUrl.ExpandAll();
                list = null;
                root = null;
                son = null;
                rnode = null;
            }
        }
        private void LoopUrlNode(TreeNode root, List<UrlNode> list)
        {
            string parentid = null;
            List<UrlNode> son = null;
            List<UrlNode> subson = null;
            TreeNode tmpNode = null;

            if (list != null && list.Count > 0)
            {
                parentid = root.Tag.ToString().Trim();
                son =
                    (from obj in list
                     where obj.ParentID.Equals(parentid)
                     select obj).ToList<UrlNode>();
                if (son != null && son.Count > 0)
                {
                    // 升序排序
                    son.Sort(delegate(UrlNode x, UrlNode y)
                    {
                        return Comparer<string>.Default.Compare(x.SortCode, y.SortCode);
                    }
                    );

                    for (int i = son.Count; i > 0; i--)
                    {
                        tmpNode = new TreeNode()
                        {
                            Text = son[0].Title,
                            ToolTipText = son[0].Desc,
                            Tag = son[0].ID
                        }; 

                        this.LoopUrlNode(tmpNode, list);

                        // 回收资源
                        list.Remove(son[0]);
                        son.RemoveAt(0);

                        root.Nodes.Add(tmpNode);
                    }
                }
            }

            // 资源回收
            parentid = null;
            son = null;
            tmpNode = null;
        }
        private void BindUrlNodeHandler(object sender, EventArgs e)
        {
            this.BindUrlNode(this.curUrlNode.CatalogID);
        }

        /// <summary>
        /// 构造历史记录树形图
        /// </summary>
        /// <param name="BeforeDay"></param>
        private void BindUrlHistory(int BeforeDay)
        {
            List<UrlNode> list = null;
            List<UrlNode> root = null;
            List<UrlNode> son = null;
            TreeNode rnode = null; 

            if (tvHistory.Nodes != null && tvHistory.Nodes.Count > 0)
            {
                return;
            }

            try
            {
                list = MyAction.GetUrlNode(
                    new UrlNode()
                    {
                         BeginTime = DateTime.Parse(DateTime.Now.ToString("yyyy/MM/dd 00:00:00")).AddDays(-BeforeDay),
                         EndTime = DateTime.Parse(DateTime.Now.ToString("yyyy/MM/dd 23:59:59"))
                    }
                    );

                if (list != null && list.Count > 0)
                {
                    root =
                        (from obj in list
                         where obj.ParentID.Equals("")
                         select obj).ToList<UrlNode>();

                    if (root == null || root.Count == 0)
                    {
                        MessageBox.Show("数据没有根节点，\n\n请联系管理员检查数据！", "", MessageBoxButtons.OK);
                        return;
                    }

                    // 升序排序
                    root.Sort(delegate(UrlNode x, UrlNode y)
                    {
                        return Comparer<string>.Default.Compare(x.SortCode, y.SortCode);
                    });
                    for (int i = root.Count; i > 0; i--)
                    {
                        rnode = new TreeNode()
                        {
                            Text = root[0].Title,
                            ToolTipText = root[0].Desc,
                            Tag = root[0].ID
                        };

                        tvUrl.Nodes.Add(rnode);

                        this.LoopUrlNode(rnode, list);

                        // 回收资源
                        list.Remove(root[0]);
                        root.RemoveAt(0);
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(string.Format("发生异常:\n{0}", ex.Message), "", MessageBoxButtons.OK);
                return;
            }
            finally
            {
                tvUrl.ExpandAll();
                list = null;
                root = null;
                son = null;
                rnode = null;
            }
        }

        /// <summary>
        /// 数据绑定 分类信息
        /// </summary>
        /// <param name="refrash"></param>
        private void BindCatalog(bool refrash)
        {
            List<Catalog> list = null;
            cbxCatalogType.ValueMember = "ID";
            cbxCatalogType.DisplayMember = "Title";
            if (refrash)
            {
                list = MyAction.GetAllCatalog();
                V_Catalog = list;
                cbxCatalogType.DataSource = list;
            }
            else
            {
                cbxCatalogType.DataSource = V_Catalog;
            }
        }

        /// <summary>
        /// 隐藏浮动菜单
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ctmsUrl_MouseLeave(object sender, EventArgs e)
        {
            this.ctmsUrl.Hide();
        }

        /// <summary>
        /// 打开网址
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void tvUrl_Click(object sender, EventArgs e)
        {
            UrlNode obj = null;
            List<UrlNode> list = null;
            if (tvUrl.SelectedNode != null)
            {
                obj = new UrlNode()
                {
                    ID = tvUrl.SelectedNode.Tag.ToString().Trim()
                };

                list = MyAction.GetUrlNode(obj);
                if (list != null && list.Count > 0)
                {
                    txtUrl.Text = list[0].Url;
                    if (list[0].Url != null && list[0].Url != "" && list[0].Url != "about:blank")
                    {
                        wbsMain.Navigate(list[0].Url);
                    }
                } 
            }
        }

        private void tabControl1_Selected(object sender, TabControlEventArgs e)
        {
            if (tabControl1.SelectedIndex == 1 && tvHistory.Nodes.Count == 0)
            {
                this.BindUrlHistory(MySettings.QueryHistoryDay);
            }
        }
    }
}
